Unit ExtRBtn; { Extended RadioButton }

{ Erweitert um Ereignis OnChange durch Achim Kaluza CIS 100332,3712

  Hallo liebe Delphi-Freunde,

  ich halte das OnChange-Event bei vielen Controls fr unverzichtbar,
  weil es eine Menge Statusabfrage-Codierung erspart. Aus einer kon-
  kreten Notwendigkeit heraus entstand diese abgewandelte Komponente.
  Falls jemand andere Komponenten ebenfalls um das fehlende OnChange-
  Event oder andere Features erweitert hat und bereit ist, mir diese
  zur Verfgung zu stellen, wrde ich mich freuen.
  Diese Komponente darf frei verwendet werden.
  Es besteht keinerlei Funktionsgarantie seitens des Autors. Fr Bug-
  Reports und Anregungen wre ich dankbar.

}

interface

uses
  WinProcs, Messages, Classes, StdCtrls, Controls;

type
  TExtRadioButton = Class(TRadioButton)
	 Private
		FOnChange: TNotifyEvent;
		FChecked: Boolean;
		procedure Click; override;
		procedure SetChecked(Value: Boolean);
		procedure CNCommand(var Message: TWMCommand); message CN_COMMAND;
	 Published
		property OnChange: TNotifyEvent read FOnChange write FOnChange;
	 Public
		constructor Create(AOwner: TComponent); override;
		property Checked: Boolean read FChecked write SetChecked;
	 end;

procedure Register;

implementation

constructor TExtRadioButton.Create;
begin
  Inherited Create(AOwner);
end;

procedure TExtRadioButton.Click;
begin
  Inherited Click;
  if assigned(FOnChange) then FOnChange(self);
end;

procedure TExtRadioButton.SetChecked(Value: Boolean);

  procedure TurnSiblingsOff;
  var
	 I: Integer;
	 Sibling: TControl;
  begin
	 if Parent <> nil then
		with Parent do
		  for I := 0 to ControlCount - 1 do
		  begin
			 Sibling := Controls[I];
			 if (Sibling <> Self) and (Sibling is TExtRadioButton) then
				TExtRadioButton(Sibling).SetChecked(False);
		  end;
  end;

begin
  if FChecked <> Value then
  begin
	 FChecked := Value;
	 TabStop := Value;
	 if HandleAllocated then
		SendMessage(Handle, BM_SETCHECK, Cardinal(Checked), 0);
	 if assigned(FOnChange) then FOnChange(self);
	 if Value then
	 begin
		TurnSiblingsOff;
		Click;
	 end;
  end;
end;

procedure TExtRadioButton.CNCommand(var Message: TWMCommand);
begin
  case Message.NotifyCode of
	 BN_CLICKED: SetChecked(True);
	 BN_DOUBLECLICKED: DblClick;
  end;
end;

procedure Register;
begin
  RegisterComponents('Standard', [TExtRadioButton]);
end;

end.

